	page	60, 132
	name	bcpprtl
	title	Borland C++ 2.0 Run-Time Library Support Package, Version 2.00

;
;	Borland C++ 2.0 Run-Time Library Definition and Initialization
;	Copyright (C) 1991 Paradigm Systems.  All rights reserved.
;
;	Function		
;	========
;	This module is responsible for the installation and initialization
;	for Borland C++ 2.0 run-time libraries.  Specific functions supported
;	include
;		Borland C++ Int 21h emulation (Console I/O)
;		Dynamic memory management (DMM)
;
;	The Int 21h emulation is always installed and requires that a function
;	InitDOSEMU be defined as part of the Int 21h emulation code.
;

	INCLUDE	startup.inc		; Macros and other assembly langauge defintions
	INCLUDE	bcpp20.inc		; Include definitions

IFDEF	TDREM
	SHOW	<Building Paradigm TDREM-compatible library support>
ENDIF	; TDREM

DMM		=	1		; Define for dynamic memory management
STDIO		=	1		; Define for stream I/O

IFDEF	DMM
	SHOW	<Including dynamic memory management support>
;
;	Define the MCB structure and segment address of the end of the
;	far heap.
;
mcb	struc
mcb_id		db	?		; ID field 
mcb_owner	dw	?		; Owner 
mcb_size	dw	?		; Initial size 
mcb	ends

HEAPEND		equ	0800h		; Define this symbol to be the last
					; segment in the far heap 
ENDIF	; DMM


	subttl	Segment ordering/alignment section
	page
;
;	Segments declared/referenced from this module
;
DefSeg	_text,       word,  public,  CODE,       <>	; Default code
DefSeg	_data,       word,  public,  DATA,       DGROUP
DefSeg	_bss,        word,  public,  BSS,        DGROUP
IFDEF	DMM
DefSeg	farheap,     para,  public,  FARHEAP,    <>
DefSeg	bheap,       para,  public,  FARHEAP,    <>
ENDIF	; DMM
IFDEF	STDIO
DefSeg	_cvtseg,     word,  public,  DATA,       DGROUP
DefSeg	_scnseg,     word,  public,  DATA,       DGROUP
ENDIF	; STDIO
DefSeg	_INIT_,      word,  public,  INITDATA,   IGROUP	; Initializers

;
;	External defintions
;
ExtProc	_startup			; Startup code entry point
IFDEF	STDIO
	SHOW	<Including stream I/O support>
ExtProc	_setupio, near			; Required to pull in initializer
ENDIF	; STDIO

	page
_text	segment
	assume	cs:_text, ds:dgroup

IFDEF	DMM
;
;	Function: InitDMM
;
;	This initialization function is responsible for initializing the
;	near and far heaps for dynamic memory management.
;

InitDMM	proc	far
	mov	ax, farheap		; Get the base of the initial MCB 
	mov	es, ax			; Address it via ES:BX 
	mov	bx, 0
	assume	es:farheap

	mov	es:[bx.mcb_id], 'Z' 	; Last block in the chain 
	mov	es:[bx.mcb_owner], 0	; No owner 
	mov	dx, HEAPEND		; Get the far heap end frame
	mov	ax, bheap		; And the start of the heap

	mov	wptr _heaptop+2, dx	; Top of the heap marker
	mov	wptr _brklvl+2, ax	; Current allocation point
	mov	wptr _heapbase+2, ax	; Allocation base
	mov	_psp, ax		; PSP for memory management

	sub	dx, ax			; Subtract the base frame number 
	mov	es:[bx.mcb_size], dx	; Set the initial allocation block size 

	ret				; Initialization complete
InitDMM	endp
ENDIF	; DMM

BegProc	_IOERROR, near			; Error code translation
	push	bp
	mov	bp, sp			; Prepare the stack frame
	mov	ax, [bp+4]		; After IP
	mov	_doserrno, ax
	pop	bp
	ret	2			; Pascal - must cleanup the stack
EndProc	_IOERROR

BegProc	_exit				; Handle exit conditions
IFNDEF	TDREM				; ROMable code branch
	jmp	_startup		; Application dependent
ELSE
	mov	bp, sp			; Prepare the stack frame
IF	@CodeSize EQ MM_NEAR
	mov	ax, [bp+2]		; After IP
ELSE
	mov	ax, [bp+4]		; After CS:IP
ENDIF	; MM_NEAR
	xor	bx, bx			; Address the interrupt vector table
	mov	es, bx

	pushf				; Push the PSW
	push	bx			; IP
	push	bx			; CS
	jmp	dptr es:[000ch]		; Call the TDREM break handler
ENDIF	; TDREM
EndProc	_exit

BegProc	_exitclean, near		; Borland C++ exit routine
	pop	cx			; Clear IP (leave the exit code)
	call	pptr __exit		; Call the exit routine (no return)
EndProc	_exitclean

BegProc	abort				; RTL abort()
IFDEF	TDREM
	mov	ax, TDE_ABORT		; Abort error code for TDREM
ELSE
	mov	ax, 3			; RTL-compatible abort error code
ENDIF
	push	ax
	call	pptr __exit		; Call the exit routine (no return)
EndProc	abort

;
;	Stack overflow checking support
;
public	N_OVERFLOW@, F_OVERFLOW@, OVERFLOW@
N_OVERFLOW@	label	near
F_OVERFLOW@	label	far
OVERFLOW@	proc
IFNDEF	TDREM				; ROMable code branch
	jmp	_startup		; Application dependent
ELSE
	mov	ax, TDE_STKOVL		; Stack overflow code for TDREM
	push	ax
	call	pptr __exit		; Call the exit routine (no return)
ENDIF	; TDREM
OVERFLOW@	endp

public	DGROUP@
DGROUP@	dw	dgroup			; Used by RTL code
_text	ends

_data	segment
GlobalW	_version, 0a02h
IFDEF	DMM
IF	@DataSize EQ MM_NEAR		; Small or medium models
;
;	Define the small data memory model variables
;
extrn	edata : word
public	___brklvl, ___heaptop, ___heapbase
___brklvl	dw	dgroup:edata	; Name clashes with macros
___heaptop	dw	dgroup:edata
___heapbase	dw	dgroup:edata
ENDIF	; Small or medium memory models
;
;	Define the far heap control variables
;
GlobalD	_brklvl, 0
GlobalD	_heaptop, 0
GlobalD	_heapbase, 0
ENDIF	; DMM
_data	ends

_bss	segment				; Uninitialized data
GlobalW	errno				; RTL error numbers
GlobalW	_doserrno
GlobalW	_psp				; PSP is used by memory management
_bss	ends

IFDEF	STDIO
_cvtseg	segment				; Segments used run-time libraries
LabelW	_RealCvtVector, public
_cvtseg	ends
_scnseg	segment
LabelW	_ScanTodVector, public
_scnseg	ends
ENDIF	; STDIO

IFDEF	DMM
farheap		segment			; Holds the first MCB in the chain
	db	16 dup (?)
farheap		ends
bheap	segment				; Actual start of the far heap
	db	16 dup (?)		; Prevent aliasing
bheap	ends
ENDIF	; DMM

;
;	This code is used to add a pointer to the initialization routine
;	into the external initializers segment.  The Borland C++ startup code
;	calls each initialization routine, guaranteeing that the code
;	can be initialized without modifications to the program or the
;	startup code.

ExtProc	InitInt21h, far			; Borland C++ 2.0 Int 21h initialization

_INIT_	segment
	InitRec	<MM_FAR, 000h, offset InitInt21h, seg InitInt21h >
IFDEF	DMM
	InitRec	<MM_FAR, 001h, offset InitDMM, seg InitDMM >
ENDIF	; DMM
_INIT_	ends

	end
