	page	60, 132
	name	bcpp31
	title	Borland C++ Compiler Startup Code, Version 1.01

;
;	Embedded System Startup Code for Borland C++ 3.10
;	Copyright (C) 1992 Paradigm Systems.  All rights reserved.
;
;	Assemble with MASM/TASM as follows:
;
;		masm bcpp31 /mx /d__MDL__ ;
;		tasm bcpp31 /mx /d__MDL__
;
;	where
;		__MDL__ is one of the following:
;
;		__s__	Small memory model
;		__c__	Compact memory model
;		__m__	Medium memory model
;		__l__	Large memory model
;
;	If no memory model is specified, the small memory model is
;	assumed and a warning is issued.
;
;	The symbol TDREM should be defined if the application will be
;	debugged with the Paradigm Turbo Debugger Interface to permit
;	exiting to the debugger or intercepting exceptions.
;
	
	INCLUDE	startup.inc		; Macros and other assembly langauge defintions
	INCLUDE	bcpp31.inc		; Compiler-specific defintions
	SHOW	<Paradigm LOCATE Borland C++ 3.10 Startup Support>
IFDEF	TDREM
	SHOW	<Building Paradigm TDREM-compatible startup code>
ENDIF	; TDREM

	subttl	Segment ordering/alignment section
	page
;
;	Segment and group declarations.  The order of these declarations is
;	used to control the order of segments in the .EXE file since the
;	Microsoft and Borland linkers copy segments in the same order they
;	are encountered in the object files.
;
;	Make sure that this startup module is specified first when linking
;	the application.  Requires MASM 5.10 or TASM 2.0 (or later) to
;	assemble.
;
DefSeg	begtext,     para,  public,  CODE,       <>	; Start CODE class
DefSeg	_text,       word,  public,  CODE,       <>
DefSeg	_bfd,        para,  public,  FAR_DATA,   <>	; Start FAR_DATA class
DefSeg	_efd,        para,  public,  ENDFAR_DATA,<>	; End FAR_DATA class

;
;	The following segments are used to hold the linked initializers
;	and terminators.  These permit automatic initialization of code
;	without startup source modification and should be located in ROM.
;	Terminators are not implemented since an application will normally
;	not return to the startup code but are supported for run-time library
;	compatibility.
;
DefSeg	_INIT_,      para,  public,  INITDATA, IGROUP	; Initializers
DefSeg	_INITEND_,   byte,  public,  INITDATA, IGROUP
DefSeg	_EXIT_,      dword, public,  EXITDATA, IGROUP	; Terminators
DefSeg	_EXITEND_,   byte,  public,  EXITDATA, IGROUP

;
;	The following segments are used to mark the place for ROM copies
;	of initialized data for use by the startup code.
;
DefSeg	romdata,     para,  public,  ROMDATA,    <>
DefSeg	erdata,      para,  public,  ENDROMDATA, <>

DefSeg	begdata,     para,  public,  DATA,       DGROUP
DefSeg	_data,       word,  public,  DATA,       DGROUP
DefSeg	_bss,        word,  public,  BSS,        DGROUP
DefSeg	_bssend,     word,  public,  BSSEND,     DGROUP

;
;	Two stack segments are declared, one for emulators that expect
;	a segment called STACK and the actual BC++ _STACK segment.
;
IF	@DataSize EQ MM_NEAR		; Stack is part of DGROUP
DefSeg	stack,       para,  stack,   STACK,      DGROUP
DefSeg	_stack,      para,  stack,   STACK,      DGROUP
ELSE					; Stack is independent of DGROUP
DefSeg	stack,       para,  stack,   STACK,      <>
DefSeg	_stack,      para,  stack,   STACK,      <>
ENDIF	; MM_NEAR

;
;	Constants used for huge pointer arithmetic
;
	public  __AHINCR, __AHSHIFT
__AHINCR	equ	1000h
__AHSHIFT	equ	12


;
;	Make up the correct external references that depend on the
;	memory model and inform the user which code and data memory
;	models have been selected.
;
ExtProc	main				; Borland C++ language entry point

	subttl	Startup code section
	page
_text	segment
	assume	cs:_text

BegProc	_startup, far			; Borland C++ startup code entry point
IFDEF	TDREM
;	Check if the segment registers have been setup by DOS.  TDREM always
;	clears the DS segment register so it can be used to check if the
;	application is accidently running under MS-DOS.

	mov	ax, es			; See if DOS setup ES
	or	ax, ax			; Check if the PSP is zero
	jz	embedded		; Continue with the embedded code

	push	cs			; Display a DOS error message
	pop	ds
	assume	ds:_text
	mov	dx, offset errmsg
	mov	ah, 09h
	int	21h
	mov	ah, 04ch		; Exit before doing something harmful
	int	21h			; No return from this DOS call
errmsg	db	"Embedded application: DOS not supported", 0ah, 0dh, '$'
embedded:
ENDIF	; TDREM				; MS-DOS error check

	cli				; Disable interrupts
	cld				; Make sure the direction is forward

;
;	Set up the stack according to the memory model.  The default Borland
;	model is to have the stack after the heap in the small and medium
;	memory models.
;
IF	@DataSize EQ MM_NEAR
	mov	ax, dgroup		; Get the frame number for the group
	mov	ss, ax			; Load in the stack segment register
	mov	sp, offset dgroup:tos	; And the offset within the group
	assume	ss:dgroup
ELSE
	mov	ax, stack		; Get the frame number for the segment
	mov	ss, ax			; Load in the stack segment register
	mov	sp, offset tos		; And the offset within the segment
	assume	ss:_stack
ENDIF	; @DataSize

;
;	Prepare the segment registers for initialization.  The initialized
;	data is assumed to have been located in the class ROMDATA which begins
;	with the segment of the same name.
;
	mov	ax, dgroup		; The destination segment for DGROUP
	mov	es, ax
	mov	ax, romdata		; The source segment
	mov	ds, ax
	assume	ds:romdata, es:dgroup

;
;	Copy DGROUP from its position in ROM to the target address in RAM
;
	mov	si, offset ridata	; Offset of the duplicated class
	mov	di, offset dgroup:idata	; Get the starting offset of the DATA segment
	mov	cx, offset dgroup:bdata	; Get the ending offset (start of BSS)
	sub	cx, di			; Subtract the two for a length
	shr	cx, 1			; Convert to words
	jcxz	$$1			; Skip if zero length
	rep	movsw			; Copy initialized data from ROM to RAM
$$1:

;
;	Setup the segment registers
;
	mov	ax, dgroup		; Address DGROUP via DS
	mov	ds, ax
	mov	es, ax
	assume	ds:dgroup, es:dgroup

;
;	Zero out the BSS area
;
	xor	ax, ax			; Use a zero fill pattern
	mov	di, offset dgroup:bdata	; Get the start of the BSS class
	mov	cx, offset dgroup:EDATA	; Get the end address
	sub	cx, di			; Subtract the two for a length
	shr	cx, 1			; Convert to the number of words
	jcxz	$$9			; Skip if zero
	rep	stosw			; Zero out the BSS
$$9:

;
;	Call all of the linked-in initializers in the _INIT_ segment.  These
;	are a series of pointers to routines which are guaranteed to
;	execute before main() is called.  The advantage of this approach is
;	that the initialization will be made by virtue of the code being
;	linked in, without any modification to the startup code.
;
;	This implementation permits the initializers to be kept in ROM,
;	even though there is no ordering of the initializers.  The register
;	use is as follows:
;		SI - initializers start
;		DI - initializers end
;		CX - number of initializers not processed
;		BX - current initializer
;		AH - current priority
;
	mov	si, offset igroup:InitStart	; Start of initializers
	mov	di, offset igroup:InitEnd	; End of initializers
	mov	ax, igroup
	mov	es, ax
	assume	es:nothing

	mov	ax, di
	sub	ax, si
	sub	dx, dx
	mov	cx, SIZE InitRec
	idiv	cx
	mov	cx, ax			; Number of initializers in the table
	jcxz	InitDone
	sub	ah, ah			; Start with the highest priority

PriTop:
	mov	bx, si			; Point to the start of the table

NextInit:
	cmp	bx, di			; Check if this pass is done
	jae	PriBottom		; Process the next priority level
	cmp	es:[bx.pri], ah		; Compare against the current priority
	jne	TableBottom		; Not our turn to execute

	push	es
	push	ax
	push	bx
	push	cx
	push	si
	push	di
	cmp	es:[bx.ctype], MM_NEAR	; Is it near or far?
	je	@@NearCall
	call	dptr es:[bx.foff]	; Call the initializer
	jmp	short $$14
@@NearCall:
	call	wptr es:[bx.foff]	; Call the initializer
$$14:
	pop	di
	pop	si
	pop	cx
	pop	bx
	pop	ax
	pop	es
	dec	cx			; Decrement the initializer count
	jz	InitDone		; Exit if done

TableBottom:
	add	bx, SIZE InitRec	; Move to the next initializer
	jmp	NextInit

PriBottom:
	inc	ah			; Process the next priority
	jmp	PriTop
InitDone:

;
;	Call the C/C++ entry point - initialization complete.
;
	sti				; Enable interrupts
	xor	bp, bp			; Mark the start of the stack frame
	call	main			; Call the Borland C++ main()

IFNDEF	TDREM				; ROMable code branch
	jmp	_startup		; Application dependent
ELSE
;
;	Hand over control to the exit handler, passing any exit code returned
;	by the application.
;
	and	ax, 7fh			; Mask for TDREM codes
	push	ax
	xor	bx, bx			; Address the interrupt vector table
	mov	es, bx
	pushf				; Push the PSW
	push	bx			; IP
	push	bx			; CS
	jmp	dptr es:[000ch]		; Call the TDREM break handler
ENDIF	; TDREM
EndProc	_startup

_text	ends

	subttl	Data declarations
	page
;
;	Run-time libraries and other modules can insert initializers in this
;	segment.  Initializers are executed by priority, and by link order
;	when the same priority.  Static destructors are not implemented since
;	we assume that the application never terminates.
;
_INIT_		segment
InitStart	label	dword
_INIT_		ends
_INITEND_	segment
InitEnd		label	dword
_INITEND_	ends
_EXIT_		segment
ExitStart	label	dword
_EXIT_		ends
_EXITEND_	segment
ExitEnd		label	dword
	db	16 dup (?)		; Force the next segment to a new paragraph
_EXITEND_	ends

romdata	segment				; Segment placeholder for initialized data
public	ridata
ridata	label	byte			; Mark the start of the ROM data area where
					; the ROM copy of initialized data is stored
romdata	ends
erdata	segment				; ROMDATA class end marker
	db	16 dup (?)		; Force the next segment to a new paragraph
erdata	ends

_bfd	segment				; Segment placeholder for far data segments
public	rfdata
rfdata	label	byte			; Mark the start of the far data area
_bfd	ends
_efd	segment				; ROMDATA class end marker
	db	16 dup (?)		; Force the next segment to a new paragraph
_efd	ends

_data	segment
public	idata
idata	label	byte			; Mark the start of the _DATA segment
null	dw	055aah			; NULL address (within the segment)
_data	ends

_bss	segment
public	bdata				; Mark the start of the BSS class
bdata	label	byte			; and the end of the DATA class
_bss	ends
_bssend segment				; BSS class end marker
public	EDATA
	dw	?			; Give a fixed size for alignment
EDATA	label	word			; Mark the end of the BSS class
_bssend ends

_stack	segment
public	tos				; Make the TOS visible to debuggers and ICE
IFDEF	STKSIZE
	db	STKSIZE dup (?)		; Setup the stack
_data	segment
GlobalW	_stklen, STKSIZE		; Needed for stack checking logic
_data	ends
ELSE
	db	2048 dup (?)	 	; Declare the stack size (in words)
_data	segment
GlobalW	_stklen, 2048			; Needed for stack checking logic
_data	ends
	SHOW	<No stack size specified: stack size set to 2KB>
ENDIF
	even				; Force word alignment
tos	label	word			; Define the top of stack (the initial SP value)
_stack	ends

	end	_startup		; Program entry point
