	page	60, 132
	name	bcpprtl
	title	Borland C++ 3.10 Run-Time Library Support, Version 2.00

;
; Borland C++ 3.10 Run-Time Library Definition and Initialization
; Copyright (C) 1991, 1992 Paradigm Systems.  All rights reserved.
;
; Function		
; ========
; This module is responsible for the installation and initialization
; of the Borland C++ 3.10 run-time library support functions.  This
; module must be linked in anytime the floating point, stream I/O,
; dynamic memory management, or other run-time library functions
; needing definitions contained herein.
;

	INCLUDE	startup.inc		; Macros and other assembly langauge defintions
	INCLUDE	bcpp31.inc		; Include definitions

IFDEF	TDREM
	SHOW	<Building Paradigm TDREM-compatible library support>
ENDIF	; TDREM

;
; External defintions
;
ExtProc	_startup			; Startup code entry point for errors

	subttl	Segment ordering/alignment section
	page
;
; Segments declared/referenced from this module
;
DefSeg	_text,       word,  public,  CODE,       <>	; Default code
DefSeg	_data,       word,  public,  DATA,       DGROUP
DefSeg	_bss,        word,  public,  BSS,        DGROUP
DefSeg	_INIT_,      word,  public,  INITDATA,   IGROUP	; Initializers

	page
_text	segment
	assume	cs:_text, ds:dgroup

BegProc	_IOERROR, near			; Error code translation
	push	bp
	mov	bp, sp			; Prepare the stack frame
	mov	ax, [bp+4]		; After IP
	mov	_doserrno, ax
	pop	bp
	ret	2			; Pascal - must cleanup the stack
EndProc	_IOERROR

BegProc	_cleanup			; Call #pragma exit routines
	ret				; Never called by Paradigm startup
EndProc	_cleanup

BegProc	_checknull			; Check for null pointers
	ret				; Never called by Paradigm startup
EndProc	_checknull

BegProc	_restorezero			; Restore hooked interrupt vectors
	ret				; Never called by Paradigm startup
EndProc	_restorezero

BegProc	__ErrorMessage			; Needed for pure function support
	ret				; Will call exit() if using DOS
EndProc	__ErrorMessage

BegProc	_terminate			; Exit program with error code
IFNDEF	TDREM				; ROMable code branch
	jmp	_startup		; Application dependent
ELSE
	mov	bp, sp			; Prepare the stack frame
IF	@CodeSize EQ MM_NEAR
	mov	ax, [bp+2]		; After IP
ELSE
	mov	ax, [bp+4]		; After CS:IP
ENDIF	; MM_NEAR
	xor	bx, bx			; Address the interrupt vector table
	mov	es, bx

	pushf				; Push the PSW
	push	bx			; IP
	push	bx			; CS
	jmp	dptr es:[000ch]		; Call the TDREM break handler
ENDIF	; TDREM
EndProc	_terminate

BegProc	abort				; RTL abort()
IFDEF	TDREM
	mov	ax, TDE_ABORT		; Abort error code for TDREM
ELSE
	mov	ax, 3			; RTL-compatible abort error code
ENDIF
	push	ax
	call	pptr _terminate		; Call the exit routine (no return)
EndProc	abort

;
; Stack overflow checking support
;
public	N_OVERFLOW@, F_OVERFLOW@, OVERFLOW@
N_OVERFLOW@	label	near
F_OVERFLOW@	label	far
OVERFLOW@	proc
IFNDEF	TDREM				; ROMable code branch
	jmp	_startup		; Application dependent
ELSE
	mov	ax, TDE_STKOVL		; Stack overflow code for TDREM
	push	ax
	call	pptr _terminate		; Call the exit routine (no return)
ENDIF	; TDREM
OVERFLOW@	endp

public	DGROUP@
DGROUP@	dw	dgroup			; Used by RTL code
_text	ends

_data	segment
GlobalW	_version, 0a02h			; Emulated DOS version number
_data	ends

_bss	segment				; Uninitialized data
GlobalW	errno				; RTL error numbers
GlobalW	_doserrno
_bss	ends

	end
