/*
//		Sample application to test dynamic memory allocation by randomly
//		allocated and freeing random sized blocks of memory.  This demo
//		assumes that the Paradigm dynamic memory management (DMM) functions
//		be linked in.
*/

#include	<stddef.h>
#include	<stdlib.h>
#include	<string.h>


#define	random(x)	(rand() % (x))
#define	ALLOCS		250				/* Number of allocations */
#define	BLOCK_SIZE	100				/* Maximum block size */

char	*p[ALLOCS] ;						/* Allocated memory block pointers */


void		main(void)
{
	unsigned	int	item ;				/* Index to block handle */
	unsigned	int	size ;				/* Requested block size */
	unsigned	int	allocs ;				/* Number of successful allocations */
	unsigned int	errors ;				/* Number of failed allocations */


	for (allocs = errors = 0;;)   {
		/* Compute the pointer and allocation size */
		item = random(ALLOCS) ;
		size = random(BLOCK_SIZE) + 1 ;

		/* Free up the memory if in use */
		if (p[item] != NULL)
			free(p[item]) ;

		/* Allocate a new block */
		if ((p[item] = malloc(size)) == NULL)
			errors++ ;
		else   {
			allocs++ ;
			memset(p[item], item, size) ;
		}
	}
}
