	page	60, 132
	name	chkstk
	title	ROMable Microsoft C 5.1 Stack Checking, Version 2.00

;
;	Copyright (C) 1988, 1989 Paradigm Systems.  All rights reserved.
;
;	Replacement stack checking stub for Microsoft library routines
;	compiled with stack checking enabled.  On entry, AX contains the
;	number of bytes to be allocated on the stack for the local frame.
;	On exit, the SP will be adjusted to allocate the space.
;
;	If insufficent space is available, the function exit() will be
;	called to report the error.  It is assumed that exit() is defined
;	elsewhere and is setup to properly handle the stack overflow exception.
;

	INCLUDE	startup.inc		; Macros and other assembly langauge defintions
	INCLUDE	msc51.inc		; MSC 5.1 specific defintions

	subttl	Segment ordering/alignment section
	page
;
;	Segments declared/referenced from this module
;
DefSeg	_text,    word,  public,  CODE,	       <>	; Default code
DefSeg	stack,    para,  stack,   STACK,       DGROUP	; Program stack


ExtProc	exit				; Destintation in case of overflow
extrn	edata : word			; Offset for the bottom of the stack

_text	segment
	assume	cs:_text, ds:dgroup, ss:dgroup

BegProc	_chkstk
;
;	Begin by saving the return address from the stack
;
	pop	cx			; Get the return offset
IF	@CodeSize NE MM_NEAR		; Check for far code pointers
	pop	dx			; Get the return segment
ENDIF
	mov	bx, sp			; Get the current stack pointer offset
	sub	bx, ax			; Adjust the stack by the specified amount
	jb	no_space		; Report the error if the sign changed

;
;	See if the bottom of the stack has been reached.  This is checked
;	by comparing the new stack pointer offset with the offset defined
;	in the stack segment declaration.
;
	cmp	bx, offset edata	; Check for reaching the bottom of the stack
	jb	no_space		; Report the error

	mov	sp, bx			; Restore the new stack pointer offset

IF	@CodeSize NE MM_NEAR		; Check for far code pointers
	push	dx			; Push the return segment
ENDIF
	push	cx			; Push the return offset

	ret				; Return - no errors

no_space:
	mov	ax, TDE_STKOVL		; TDREM stack overflow error code
	push	ax
	call	exit
EndProc	_chkstk

_text	ends

	end
