	page	60, 132
	name	chkstk
	title	ROMable Microsoft C 6.00A Stack Checking, Version 2.01

;
;	Copyright (C) 1990 Paradigm Systems.  All rights reserved.
;
;	Replacement stack checking stub for Microsoft library routines
;	compiled with stack checking enabled.  On entry, AX contains the
;	number of bytes to be allocated on the stack for the local frame.
;	On exit, the SP will be adjusted to allocate the space.
;
;	If insufficent space is available, the function exit() will be
;	called to report the error.  It is assumed that exit() is defined
;	elsewhere and is setup to properly handle the stack overflow exception.
;

	INCLUDE	startup.inc		; Macros and other assembly langauge defintions
	INCLUDE	msc60.inc		; MSC 6.0 specific defintions

	subttl	Segment ordering/alignment section
	page
;
;	Segments declared/referenced from this module
;
DefSeg	_text,    word,  public,  CODE,	       <>	; Default code
DefSeg	stack,    para,  stack,   STACK,       DGROUP	; Program stack


IFDEF	TDREM
ExtProc	exit				; Destintation in case of overflow
ENDIF	; TDREM
extrn	edata : word			; Offset for the bottom of the stack

_text	segment
	assume	cs:_text, ds:dgroup, ss:dgroup

;
;	Near model stack checking
;

BegProc	_chkstk
BegProc	_aNchkstk
EndProc	_aNchkstk
;
;	Begin by saving the return address from the stack
;
	pop	cx			; Get the return offset
	mov	bx, sp			; Get the current stack pointer offset
	sub	bx, ax			; Adjust the stack by the specified amount
	jb	n_no_space		; Report the error if the sign changed

;
;	See if the bottom of the stack has been reached.  This is checked
;	by comparing the new stack pointer offset with the offset defined
;	in the stack segment declaration.
;
	cmp	bx, offset edata	; Check for reaching the bottom of the stack
	jb	n_no_space		; Report the error

	mov	sp, bx			; Restore the new stack pointer offset

	push	cx			; Push the return offset
	ret				; Return - no errors

n_no_space:
IFDEF	TDREM
	mov	ax, TDE_STKOVL		; TDREM stack overflow error code
	push	ax
	call	exit
ELSE
	; *** THIS IS APPLICATION DEPENDENT ***
	mov	sp, bx			; Restore the new stack pointer offset
	push	cx			; Push the return offset
	ret
	; *** THIS IS APPLICATION DEPENDENT ***
ENDIF	; TDREM
EndProc	_chkstk

;
;	Far model stack checking
;

BegProc	_aFchkstk
;
;	Begin by saving the return address from the stack
;
	pop	cx			; Get the return offset
	pop	dx			; Get the return segment
	mov	bx, sp			; Get the current stack pointer offset
	sub	bx, ax			; Adjust the stack by the specified amount
	jb	f_no_space		; Report the error if the sign changed

;
;	See if the bottom of the stack has been reached.  This is checked
;	by comparing the new stack pointer offset with the offset defined
;	in the stack segment declaration.
;
	cmp	bx, offset edata	; Check for reaching the bottom of the stack
	jb	f_no_space		; Report the error

	mov	sp, bx			; Restore the new stack pointer offset

	push	dx			; Push the return segment
	push	cx			; Push the return offset
	ret				; Return - no errors

f_no_space:
IFDEF	TDREM
	mov	ax, TDE_STKOVL		; TDREM stack overflow error code
	push	ax
	call	exit
ELSE
	; *** THIS IS APPLICATION DEPENDENT ***
	mov	sp, bx			; Restore the new stack pointer offset
	push	dx			; Push the return segment
	push	cx			; Push the return offset
	ret
	; *** THIS IS APPLICATION DEPENDENT ***
ENDIF	; TDREM
EndProc	_aFchkstk

_text	ends

	end
