	page	60, 132
	name	msc60rtl
	title	Microsoft C 6.0 Run-Time Library Support Package, Version 2.00

;
;	Microsoft C 6.0 Run-Time Library Definition and Initialization
;	Copyright (C) 1990 Paradigm Systems.  All rights reserved.
;
;	Function		
;	========
;	This module is responsible for the installation and initialization
;	for Microsoft C 6.0 run-time libraries.  Specific functions supported
;	include
;		Microsoft C Int 21h emulation (Console I/O)
;
;	The Int 21h emulation is always installed and requires that a function
;	InitDOSEMU be defined as part of the Int 21h emulation code.
;
;	*** NOTE - IMPORTANT WARNING ***
;	This module should usually be linked in last so that it is installed
;	first, ahead of any other initializers that might use an Int 21h call.
;	*** NOTE - IMPORTANT WARNING ***
;

	INCLUDE	startup.inc		; Macros and other assembly langauge defintions
	INCLUDE	msc60.inc		; MSC 6.0 specific defintions

DefSeg	_text,    word,  public,  CODE,	       <>	; Default code
DefSeg	_data,    word,  public,  DATA,        DGROUP	; Initialized data
DefSeg	xif,      word,  public,  DATA,        DGROUP	; Far initializers
DefSeg	_bss,     word,  public,  BSS,         DGROUP	; Uninitialized data

	page
ExtProc	_startup			; Destination in case of exceptions

_text	segment
	assume	cs:_text, ds:dgroup

public	__exit
__exit	proc
IFNDEF	TDREM				; ROMable code branch
	jmp	_startup		; Application dependent
ELSE
	mov	bp, sp			; Prepare the stack frame
IF	@CodeSize EQ MM_NEAR
	mov	ax, [bp+2]		; After IP
ELSE
	mov	ax, [bp+4]		; After CS:IP
ENDIF	; MM_NEAR
	xor	bx, bx			; Address the interrupt vector table
	mov	es, bx

	pushf				; Push the PSW
	push	bx			; IP
	push	bx			; CS
	jmp	dptr es:[000ch]		; Call the TDREM break handler
ENDIF	; TDREM
__exit	endp

BegProc	abort				; RTL abort()
IFDEF	TDREM
	mov	ax, TDE_ABORT		; Abort error code for TDREM
ELSE
	mov	ax, 3			; RTL-compatible abort error code
ENDIF
	push	ax
	call	pptr __exit		; Call the exit routine (no return)
EndProc	abort

BegProc	exit				; RTL exit()
IF	@CodeSize NE MM_NEAR
	pop	cx			; Get rid of CS
ENDIF	; MM_NEAR
	pop	cx			; Clear IP (leave the exit code)
	call	pptr __exit		; Call the exit routine (no return)
EndProc	exit

;
;	These are defined here to satisfy some non-public Microsoft run-time
;	libraries and hoepfully should never be called.
;
public	__NMSG_WRITE, __wrt2err, __FF_MSGBANNER
__FF_MSGBANNER:
__NMSG_WRITE:
__wrt2err:
IFNDEF	TDREM
	; *** APPLICATION DEPENDENT ***
	cli				; Stop here till reset
	hlt				; Application dependent
ELSE					; TDREM code
	call	abort			; Unknown fault
ENDIF	; TDREM

BegProc	_fptrap				; Default FP exceptions
IFDEF	TDREM				; TDREM code
	mov	ax, TDE_FPEXCP		; FP exception error code
	push	ax
	call	exit			; Report the exception
ELSE					; ROMable code
	cli				; Stop here till reset
	hlt				; Application dependent
ENDIF	; TDREM
EndProc	_fptrap

_text	ends
	
	subttl	Data Declarations
	page

_data	segment
GlobalB _osmajor, 2			; Pretend to be DOS 2.10
GlobalB _osminor, 10
_data	ends

_bss	segment
GlobalW	errno				; errno used by RTL
GlobalW	_doserrno			
GlobalW	_child
GlobalW	__aDBswpflg
GlobalW	__aDBswpchk
GlobalW	_aDBdoswp
_bss	ends

;
;	This code is used to add a pointer to the initialization routine
;	into the external initializers segment.  The Microsoft C startup code
;	calls each initialization routine, guaranteeing that the code
;	can be initialized without modifications to the program or the
;	startup code.
;

ExtProc	InitInt21h, far			; Microsoft C 6.0 Int 21h initialization

xif	segment
	dd	InitInt21h
xif	ends

	end
