	page	60, 132
	name	cinit
	title	Microsoft C/C++ 7.0 C/C++ Initializers, Version 1.00

;
;	Embedded System Startup Code for Microsoft C/C++ 7.0
;	Copyright (C) 1992 Paradigm Systems.  All rights reserved.
;
;		masm /mx /D__MDL__ cinit.asm ;
;		ml /c /Cx /D__MDL__ cinit.asm ;
;
;	where
;		__MDL__ is one of the following:
;
;		__S__	Small memory model
;		__C__	Compact memory model
;		__M__	Medium memory model
;		__L__	Large memory model
;		__H__	Huge memory model
;
;	If no memory model is specified, the small memory model is
;	assumed and a warning is issued.
;
	
	INCLUDE	startup.inc		; Macros/assembly language definitions
	INCLUDE	msc70.inc		; MSC/C++ 7.0 specific definitions
	SHOW	<Paradigm LOCATE Microsoft C/C++ 7.0 C/C++ Initializers>

	subttl	Segment ordering/alignment section
	page
;
;	Segment and group declarations.  The order of these declarations is
;	used to control the order of segments in the .EXE file since the
;	Microsoft linker copies segments in the same order they are encountered
;	in the object files.
;

DefSeg	_text,    word,  public,  CODE,	       <>
DefSeg	xipb,     word,  public,  DATA,        DGROUP
DefSeg	xip,      word,  public,  DATA,        DGROUP	; Paradigm initializers
DefSeg	xipe,     word,  public,  DATA,        DGROUP
DefSeg	xib,      word,  public,  DATA,        DGROUP
DefSeg	xi,       word,  public,  DATA,        DGROUP	; Near initializers
DefSeg	xie,      word,  public,  DATA,        DGROUP
DefSeg	xifb,     word,  public,  DATA,        DGROUP
DefSeg	xif,      word,  public,  DATA,        DGROUP	; Far initializers
DefSeg	xife,     word,  public,  DATA,        DGROUP
DefSeg	xifcb,    word,  public,  DATA,        DGROUP
DefSeg	xifu,     word,  public,  DATA,        DGROUP	; Far C++ user constructors
DefSeg	xifl,     word,  public,  DATA,        DGROUP	; Far C++ library constructors
DefSeg	xifm,     word,  public,  DATA,        DGROUP	; Far C++ MS constructors
DefSeg	xifce,    word,  public,  DATA,        DGROUP

	page
_text	segment
	assume	cs:_text

BegProc	_cinit

;
;	Call any Paradigm initializers linked in.  These must be executed
;	first to guarantee that everything is initialized for the MSC/C++
;	initializers.
;
	mov	si, offset dgroup:xipbegin
	mov	di, offset dgroup:xipend
	call	farinitterm

;
;	Call any far initializers linked in
;
	mov	si, offset dgroup:xifbegin
	mov	di, offset dgroup:xifend
	call	farinitterm

;
;	Call any near initializers linked in
;
	mov	si, offset dgroup:xibegin
	mov	di, offset dgroup:xiend
	call	initterm

;
;	Call any far C++ constructors linked in
;
	mov	si, offset dgroup:xifcbegin
	mov	di, offset dgroup:xifcend
	call	farinitterm

	ret
EndProc	_cinit

	page
;
;	This code installs the initializers/constrcutors
;

IF	@CodeSize EQ MM_FAR		; Far code models
farinitterm	proc	near
ENDIF	;	MM_NEAR

initterm	proc	near
	cmp	si, di			; Test if complete
	jae	alldone

IF	@CodeSize EQ MM_NEAR		; Near code models
	sub	di, 2
	mov	cx, [di]		; Get the initializer address
	jcxz	initterm		; Skip the null procedures
	call	cx			; Make the call
ELSE					; Far data models
	sub	di, 4
	mov	ax, [di]		; Check for a null pointer
	or	ax, [di+2]
	jz	initterm		; Skip any null procedures
	call	dptr [di]		; Call the initializer
ENDIF	;	MM_NEAR
	jmp	initterm		; Keep looping till done
alldone:
	ret
initterm	endp
IF	@CodeSize EQ MM_FAR		; Far code models
farinitterm	endp
ENDIF	;	MM_NEAR


IF	@CodeSize EQ MM_NEAR
;
;	Only needed in the near code models since the default version will
;	use far initializers automatically.
;
farinitterm	proc	near
	cmp	si, di			; Test if complete
	jae	falldone

	sub	di, 4
	mov	ax, [di]		; Check for null pointers
	or	ax, [di+2]
	jz	farinitterm		; Skip any null procedures
	call	dptr [di]		; Call the initializer
	jmp	farinitterm		; Keep looping till done
falldone:
	ret
farinitterm	endp
ENDIF	;	MM_NEAR

_text	ends

	page
;
;	Define the initializers.  The main purpose is to define symbols which
;	can be referenced to compute the number of initializers linked in at
;	run-time.
;

xipb	segment				; Start of Paradigm initializers
xipbegin label	byte
xipb	ends
xipe	segment				; End of Paradigm initializers
xipend	label	byte
xipe	ends
xib	segment				; Start of near initializers
xibegin	label	byte
xib	ends
xie	segment				; End of near initializers
xiend	label	byte
xie	ends
xifb	segment				; Start of far initializers
xifbegin label	byte
xifb	ends
xife	segment				; End of far initializers
xifend	label	byte
xife	ends
xifcb	segment				; Start of far C++ constructors
xifcbegin label	byte
xifcb	ends
xifce	segment				; End of far C++ constructors
xifcend	label	byte
xifce	ends

	end
