//
//		Sample Microsoft C++ application showing the use of the Microsoft
//		Foundation Classes in an embedded system.  In this application,
//		the string class CString is used to create and manipulate some
//		string objects.
//
//		NOTE: Do not link with the debug version of the libraries as they
//		include functionality not supported by Paradigm LOCATE.
//

#include	<iostream.h>					// C++ streams
#include	<afx.h>							// CString class definitions


int		main()
{
	int		len ;
	CString	s1 ;
	CString	s2("Hello") ;
	CString	s3 = s2 ;
	CString	s4(s2 + " " + s3) ;

 	for (;;)   {
		// Let's check the string lengths
		len = s1.GetLength() ;			// Should be 0
		len = s2.GetLength() ;			// Should be 5
		len = s3.GetLength() ;			// Should also be 5
		len = s4.GetLength() ;			// Should be 11

		// Try out the upper/lower case member functions
		s2.MakeUpper() ;
		s2.MakeLower() ;

		// Concatenate two strings and check the length
		s1 += "Now we have a length" ;
		len = s1.GetLength() ;			// Should be 20
		s1.Empty() ;						// Set back to 0

		// Now let's reverse a string
		s4.MakeReverse() ;

		// Write out strings to the console device
		cout << (const char *)(s1) << endl ;
		cout << (const char *)(s2) << endl ;
		cout << (const char *)(s3) << endl ;
		cout << (const char *)(s4) << endl ;
	}

	return	0 ;
}
