/*
//		A simple demonstration of the Microsoft C/C++ stream I/O capabilities
//		using an interactive version of the Sieve benchmark.  This example
//		reads and write memory buffers defined in the module MSC7SIO.C but can
//		be easily modified to work with a serial interface or an LCD panel.
*/

#include	<stdio.h>

#define	TRUE			1
#define	FALSE			0
#define	SIZE			1024

char	flags[ SIZE + 1 ] ;


void		main(void)
{
	register int	i, k, count ;
	unsigned	limit ;
	char		buf[20] ;


	/* Run this demo forever */
	for (;;)   {
		/* Get the number of iterations */
		printf("\nSieve upper limit? ") ;
		for (;;)   {
			gets(buf) ;
			if (sscanf(buf, "%u", &limit) == 1)   {
				if (limit >= 2 && limit <= SIZE)
					break ;
			}
			printf("Enter a number between 2 and %u: ", SIZE) ;
		}

		/* Perform the initialization */
		for (count = i = 0; i <= limit; i++)
			flags[i] = TRUE ;

		/* Run the Sieve */
		for (i = 2; i <= limit; i++)   {
			if (flags[i])   {
				/* Cancel out all multiples of this prime */
				for (k = i + i; k <= limit; k += i)
					flags[k] = FALSE ;
				count++ ;
			}
		}

		/* Display the count of primes */
		printf("%u primes found between 2 and %u\n", count, limit) ;
	}
}
