/*
//		Extensible MS-DOS Emulation for Microsoft C/C++ Embedded Systems
//		Copyright (C) 1992 Paradigm Systems.  All rights reserved.
//
//		Function		
//		========
//		This file contains the definitions common to modules implementing
//		the MS-DOS emulation for Microsoft C/C++ 7.0.
*/

#if	!defined(_DOSEMU)
#define	_DOSEMU

/*
//		Some commonly emulated DOS functions
*/

#define	DOS_TERMINATE			0x00
#define	DOS_CINPUT				0x01
#define	DOS_DIRECTIO			0x06
#define	DOS_BUFINPUT			0x0a
#define	DOS_GETSTATUS			0x0b
#define	DOS_SETVECTOR			0x25
#define	DOS_VERSION				0x30
#define	DOS_GETVECTOR			0x35
#define	DOS_READ					0x3f
#define	DOS_WRITE				0x40
#define	DOS_SEEK					0x42
#define	DOS_IOCTL				0x44
#define	DOS_ALLOC				0x48
#define	DOS_FREE					0x49
#define	DOS_REALLOC				0x4a
#define	DOS_EXIT					0x4c


/*
//		Function prototypes for the console I/O interface.
*/

void		InitConsole(void) ;
int		_getch(void) ;
int		_putch(int) ;

#endif	/* _DOSEMU */
