	page	60, 132
	name	msc7flt
	title	Microsoft C/C++ 7.0 Floating Point Package, Version 2.00
;
;	Microsoft C/C++ 7.0 Floating Point Initialization Package
;	Copyright (C) 1992 Paradigm Systems.  All rights reserved.
;
;	Function		
;	========
;	This module is responsible for the installation and initialization
;	of the 80x87/emulator/alternate floating point libraries included
;	Microsoft C/C++ 7.0 compiler.
;
;	*** IMPORTANT - READ THIS!!!! ***
;	The package requires that the MSC7RTL package be already installed
;	and support the DOS_GETVECTOR, DOS_SETVECTOR and Int 11h services.  If a
;	NEC V25/V35 or Intel 80186/188 is used, Int 7h support must also be
;	available to service the escape opcode exceptions.  This is accomplished
;	by specifying linking the MSC7RTL module after the MSC7FLT module in the
;	link response file since initializers are executed in reverse order.
;	*** IMPORTANT - READ THIS!!!! ***
;

	INCLUDE	startup.inc		; Macros and other assembly langauge defintions
	INCLUDE	msc70.inc		; MSC/C++ 7.0 specific defintions

	subttl	Segment ordering/alignment section
	page
;
;	Segments declared/referenced from this module
;
DefSeg	_text,    word,  public,  CODE,	       <>	; Default code
DefSeg	_data,    word,  public,  DATA,        DGROUP	; Initialized data
DefSeg	xif,      word,  public,  DATA,        DGROUP	; Far initializers
DefSeg	cdata,    word,  common,  DATA,        DGROUP	; Floating point link
DefSeg	hdr,      word,  public,  MSG,         DGROUP	; Pulled in by FP
DefSeg	msg,      byte,  public,  MSG,         DGROUP	;   "
DefSeg	pad,      byte,  common,  MSG,         DGROUP	;   "
DefSeg	epad,     byte,  common,  MSG,         DGROUP	;   "
DefSeg	_bss,     word,  public,  BSS,         DGROUP	; Uninitialized data

;	Segments used by the math packages
DefSeg	EMULATOR_TEXT,	para,  public,	CODE,     <>
DefSeg	EMULATOR_DATA,	para,  public,	FAR_DATA, <>

	subttl	Initalization/exception handling code
	page

ExtProc	exit				; Destination in case of exceptions
IF	FLOAT NE FPALT
ExtProc	_fpmath, far			; FP initialization definitions
ExtProc	_fptaskdata, far
ENDIF	; FPALT


_text	segment
	assume	cs:_text

BegProc	_romfpsig, far
	assume	cs:_text, ds:dgroup, ss:dgroup
;
;	This is the default signal() handler that gets executed when an
;	floating point exception occurs.
;
IFDEF	TDREM				; TDREM code
	mov	ax, TDE_FPEXCP		; FP exception error code
	push	ax
	call	exit			; Report the exception
ENDIF
	ret				; Continue
EndProc	_romfpsig


;
;	Function:  InitFPMath
;
;	This function is responsible for initializing the selected Microsoft
;	C/C++ 7.0 floating point package.
;

BegProc	_InitFPMath, far
	assume	cs:_text, ds:dgroup
	push	si			; Save the registers
	push	di
	push	ds

;
;       Install the floating point initialization and exception handlers.
;
IF	@CodeSize EQ MM_NEAR
	mov	wptr [fpmath+2], cs
ENDIF	; MM_NEAR

IF	FLOAT NE FPALT
	mov	wptr [fpmath], offset _fpmath
	mov	wptr [fpmath+2], seg _fpmath

	mov	wptr [fpdata], offset _fptaskdata
	mov	wptr [fpdata+2], seg _fptaskdata
ENDIF	; FPALT

	mov	wptr [fpsignal], offset _romfpsig
	mov	wptr [fpsignal+2], seg _romfpsig

	lds	ax, [fpdata]		; Get task data area
	assume	ds:nothing
	mov	dx, ds			; Into dx:ax
	xor	si, si			; No PSP
	xor	bx, bx			; ID = 0 - Initialize floating point
	call	dptr ss:[fpmath]	; Do it
	jnc	fpok			; Continue if the initialization was successful
	hlt	    			; Halt if we can't install the floating point package
					; *** Application dependent ***
fpok:
	pop	ds			; Clean up and exit
	assume	ds:dgroup
	pop	di
	pop	si
	ret
EndProc	_InitFPMath

_text	ends

EMULATOR_TEXT	segment
GlobalW	_EmDataSeg, EMULATOR_DATA	; Hold segment address of emulator data
EMULATOR_TEXT	ends

;
;	Check if the user has requested in-line 80x87 code or we need
;	to disable certain emulator fixups.
;
IF	FLOAT EQ FPEMU
	SHOW	<Building emulator library floating point support>

fINT	EQU	0CDH
fFWAIT	EQU	09BH
fESCAPE	EQU	0D8H
fES	EQU	026H
fCS	EQU	02Eh
fSS	EQU	036h
fDS	EQU	03Eh

BEGINT	equ	034h			; MS-DOS beginning interrupt

public	FIWRQQ, FIERQQ, FIDRQQ, FISRQQ, FJSRQQ
public	FIARQQ, FJARQQ, FICRQQ, FJCRQQ

FIWRQQ		equ	024fbh		; Convert NOP-WAIT to MOV AX, AX
FIDRQQ	EQU	(fINT + 256*(BEGINT + 0)) - (fFWAIT + 256*fESCAPE)
FIERQQ	EQU	(fINT + 256*(BEGINT + 8)) - (fFWAIT + 256*fES)
FIARQQ	EQU	(fINT + 256*(BEGINT + 8)) - (fFWAIT + 256*fDS)
FJARQQ	EQU	256*(((0 shl 6) or (fESCAPE and 03Fh)) - fESCAPE)
FISRQQ	EQU	(fINT + 256*(BEGINT + 8)) - (fFWAIT + 256*fSS)
FJSRQQ	EQU	256*(((1 shl 6) or (fESCAPE and 03Fh)) - fESCAPE)
FICRQQ	EQU	(fINT + 256*(BEGINT + 8)) - (fFWAIT + 256*fCS)
FJCRQQ	EQU	256*(((2 shl 6) or (fESCAPE and 03Fh)) - fESCAPE)

ELSEIF	FLOAT EQ FP87
	SHOW	<Building 80x87 floating point support>

public	FIWRQQ, FIERQQ, FIDRQQ, FISRQQ, FJSRQQ
public	FIARQQ, FJARQQ, FICRQQ, FJCRQQ

FIDRQQ	EQU	0			; Disable all emulator fixups
FIERQQ	EQU	0
FIWRQQ	EQU	0
FIARQQ	EQU	0
FJARQQ	EQU	0
FISRQQ	EQU	0
FJSRQQ	EQU	0
FICRQQ	EQU	0
FJCRQQ	EQU	0

ELSEIF	FLOAT EQ FPALT
	SHOW	<Building alternate math floating point support>
ENDIF	; FLOAT

cdata	segment
	 dw	0			; Force the allocation of the segment
LabelD	_fpinit, public			; Filled in later
LocalD	fpmath, 0
LocalD	fpdata, 0
LocalD	fpsignal, 0
cdata	ends

_bss	segment
GlobalQ	_fac				; RTL compatibility
_bss	ends

;
;	This code is used to add a pointer to the initialization routine
;	into the external initializers segment.  The Microsoft C/C++ startup
;	code calls each initialization routine, guaranteeing that the code
;	can be initialized without modifications to the program or the
;	startup code.
;
xif	segment
	dd	_InitFPMath		; Initializer entry point
xif	ends

	end
