/*
//		KERNEL.H		TDREM application kernel interface definitions
//
//		This file defines the user interface to the TDREM debug kernel.  This
//		interface permits an application to control the behavior of the
//		TDREM kernel without resorting to burning EPROMs.
//
//		This header should be included into the C source module that services
//		the TDREM kernel calls.
*/

#if	!defined(_KERNEL)
#define	_KERNEL

#define	TDREMINT			0xff			/* Debug kernel interrupt vector */

typedef	enum	{
		UI_NMIRESET,						/* NMI reset operation */
		UI_MASK,								/* Mask interrupts (instruction trace) */
		UI_UNMASK,							/* Unmask interrupts (instruction trace) */
		UI_ENTER,							/* TDREM kernel entry */
		UI_EXIT,								/* TDREM kernel exit */
		UI_RESET,							/* TDREM system reset emulation */
		UI_BYE								/* TDREM quit */
	} UI_KERNEL ;							/* TDREM kernel interface function codes */


/*
//		Function prototypes for the optional kernel interface.
*/
void	interrupt far	UIDefaultHandler(void) ;
void	KERNELsetvect(unsigned, void far *) ;

/*
//		This the prototype for the TDREM kernel handler.  Since MSC pushes
//		a different number of registers in a different order than TC/TC++,
//		the function prototype must be adjusted according to the compiler.
*/
void	interrupt far	TDREMHandler(unsigned, unsigned, unsigned, unsigned,
								unsigned, unsigned, unsigned, unsigned, unsigned
#if	!defined(__TURBOC__)
								, unsigned
#endif	/* __TURBOC__ */
								) ;

#endif	/* _KERNEL */
